// > *** MoReFEM Doxygen information and copyright notice *** //
/*!
 * This file is part of the [MoReFEM](https://gitlab.inria.fr/MoReFEM/CoreLibrary/MoReFEM) library.
 * It is released under the LGPL v3 license; a copy is provided in the LICENSE file shipped with it.
 *
 * MoReFEM is mostly developed by [M3DISIM team-project](https://www.inria.fr/m3disim).
 * You may contact its developers by writing at morefem-maint@inria.fr.
 *
 * \file
 *
 * \ingroup TestGroup
 * \addtogroup TestGroup
 * @{
 */
// *** MoReFEM Doxygen information and copyright notice *** < //


#include <cstddef> // IWYU pragma: keep

#include "Test/Operators/VariationalInstances/Viscoelasticity/ExpectedResults.hpp"


// NOLINTBEGIN(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers)
namespace MoReFEM::TestNS::ViscoelasticityNS
{


    template<>
    expected_results_type<LinearAlgebraNS::type::matrix>
    GetExpectedMatrixP2P1<Advanced::LocalVariationalOperatorNS::SecondPiolaKirchhoffStressTensorNS::
                              ViscoelasticityPolicyNS::DerivatesWithRespectTo::velocity>()
    {
        constexpr auto f1 = 5.3649149431264177e-02;
        constexpr auto f2 = -8.3704593644226929e-02;
        constexpr auto f3 = 1.8130088213779098e-02;
        constexpr auto f4 = -3.5703328924684814e-02;
        constexpr auto f5 = -3.7143219744708723e-02;
        constexpr auto f6 = -5.1745935418504072e-02;
        constexpr auto f7 = 9.7902401341421696e-02;
        constexpr auto f8 = 4.6948708432232304e-02;

        return expected_results_type<LinearAlgebraNS::type::matrix>{
            { 4.2164064405896318e-02,  f1,
              -1.2445195379751854e-02, 1.0503100482026315e-01,
              1.4136846958252725e-01,  2.5572342221865656e-02,
              3.7646011609989295e-02,  3.5734584454990746e-02,
              1.3125372197622878e-02,  -1.2073289847882920e-01,
              -1.1095279607991801e-01, -4.6425715637993657e-02,
              2.2806360791649616e+00,  -4.5724758352185635e-01,
              -2.0463689951694028e-01, -2.3560849532777652e+00,
              -9.4517968688293741e-01, -1.0159776896740278e+00,
              2.3401511936358212e+00,  8.6942242320509089e-01,
              1.0821427030403692e+00,  2.8959281807141513e+00,
              1.5286084104655964e+00,  1.4208044417924743e+00,
              -2.5886284977642458e+00, -1.1878651387079462e+00,
              -1.3544380478072759e+00, -2.6361101848302426e+00,
              7.2462168053188544e-02,  9.2278688763657718e-02 },
            { f1,
              1.5089102974537608e-01,
              6.4821645573828579e-02,
              7.9054916773857911e-02,
              1.3992032163644516e-01,
              2.6530239416579504e-02,
              6.2053043778228477e-02,
              7.8190340185439147e-02,
              1.1492779686202961e-01,
              -1.2867193876222988e-01,
              -5.8495753241267746e-02,
              -2.8871398642583434e-02,
              7.5294831183641597e-01,
              1.9297645301202748e+00,
              1.0335906231046295e+00,
              -9.4898691554950065e-01,
              -2.2605155160943871e+00,
              -9.6684922432581444e-01,
              -3.5835025538771081e-01,
              2.2210214414367648e+00,
              -4.9350486864142673e-01,
              1.5461851937001256e+00,
              2.6744394259552680e+00,
              1.3224607514922233e+00,
              1.0983785147221718e-01,
              -2.4351720531739258e+00,
              6.2462330708412360e-02,
              -1.1677193572926678e+00,
              -2.4400437665699886e+00,
              -1.1355678955478778e+00 },
            { -1.2445195379751826e-02, 6.4821645573828718e-02,  6.2570091123748506e-02,  -8.3817034122138315e-03,
              -1.2385812753423469e-02, -3.2132427953664798e-02, 5.1205290901662766e-02,  4.7245145934536367e-02,
              8.7634562277660144e-02,  -1.4327274855023103e-01, -1.4447416615798048e-01, -6.7520386480029587e-02,
              1.1373842337413913e+00,  1.0324067418816869e+00,  2.6798652385908199e+00,  1.2840258774193583e-01,
              2.3352405581116498e-01,  -2.5505864516529440e+00, 1.0184768520314800e+00,  8.2285952759845049e-01,
              2.3119755882358000e+00,  1.4244915954303167e-01,  7.2802364752881238e-03,  2.7720038242376397e+00,
              -1.1809145995008363e+00, -1.0898635156358178e+00, -2.7456667794959446e+00, -1.1329038771164686e+00,
              -9.6141385872773377e-01, -2.5181432588830850e+00 },
            { -4.1154476620262961e-03,
              -1.7960218583484056e-02,
              1.9730512160755307e-02,
              -8.0083688276973208e-02,
              f2,
              8.3394910120468211e-03,
              2.2010095819368559e-02,
              2.2334387185909445e-04,
              8.6058677565379997e-04,
              1.4420851282444780e-02,
              -2.0236822375674971e-03,
              -6.0425416515045096e-04,
              2.5160619027265041e-01,
              9.8291339313205994e-02,
              -2.5056405909789404e-02,
              1.1873667018412064e+00,
              -6.8340780569078038e-02,
              -7.0781534729505796e-02,
              -1.2440892172909517e+00,
              6.9025960227482613e-02,
              6.7568156091550438e-02,
              -1.4533014398941697e+00,
              -5.9487781066871998e-02,
              -1.3863959345208596e-02,
              1.4052817911040598e+00,
              6.1011349861193435e-02,
              1.3990697861128144e-02,
              -9.9095837195608966e-02,
              2.9650628274873821e-03,
              -1.8328975148028284e-04 },
            { -3.8423838314489714e-02, -7.3750857338554188e-02,
              -1.0787748250340692e-02, f2,
              -9.9569866497933313e-02, f3,
              -2.2104004726972382e-02, -5.6233321197056180e-02,
              -3.2758489692006162e-02, 3.2144071435344652e-02,
              -2.3360501835342357e-03, -6.3963838668430956e-04,
              -1.0291273835053913e+00, 1.8742351022790704e-01,
              -3.0418025993774186e-02, 1.1083370392535394e+00,
              1.2155335392145665e+00,  -1.3368804325490710e-01,
              2.5585565921316683e-01,  -1.1810787180972913e+00,
              1.8777247165932009e-01,  -1.4574360690264816e+00,
              -1.3449254733286549e+00, 1.5516707385322827e-02,
              1.1752252857173462e-02,  1.2661964918333353e+00,
              -6.6928061518869819e-02, 1.2227068664583376e+00,
              8.8740745367215421e-02,  5.3800739838160243e-02 },
            { -2.6282237241288635e-02,
              -2.5088142912497970e-02,
              -2.9100098815541681e-03,
              8.3394910120468263e-03,
              f3,
              3.7952843370738128e-02,
              -1.5254076750538114e-02,
              1.7350038058906159e-03,
              8.7893415169476010e-04,
              7.5643161614221896e-02,
              7.9214714524667551e-02,
              3.0724882964409488e-02,
              -1.2871107441319978e+00,
              2.3982302061328307e-02,
              -6.0955217980978804e-02,
              -1.0570576400759213e-01,
              -1.4656659607345068e-01,
              1.2430870342580362e+00,
              -1.1392772731282603e+00,
              1.9777479515789259e-01,
              -1.2332211566133364e+00,
              -4.4955460811677589e-02,
              1.0683396926161399e-02,
              -1.3806564541079738e+00,
              1.3109692653614231e+00,
              -1.0844983675542867e-01,
              1.3761924234837839e+00,
              1.2236336380836632e+00,
              -5.1415724948342172e-02,
              -1.1093279644819631e-02 },
            { -3.1571987392133599e-02,
              -3.9579435181664610e-02,
              -1.1694581076596166e-02,
              -3.9924809440580813e-02,
              -8.9081770215758971e-02,
              -1.0049637609213798e-02,
              -5.8853061546889393e-02,
              f4,
              f5,
              -1.0854893888142616e-03,
              1.5074076976063838e-02,
              8.1261370911798000e-05,
              -1.2261223045296714e+00,
              2.9755920206249103e-01,
              6.5087270291333002e-02,
              1.2280709803710717e+00,
              1.1273135400227838e+00,
              -6.5427492392160863e-02,
              1.2285291755453445e-01,
              -1.1301402946725587e+00,
              5.8669253055192092e-02,
              -1.4103385594928033e+00,
              -1.4392104777000254e+00,
              1.6018783266940138e-02,
              -3.3897217966855721e-02,
              1.2959823538173416e+00,
              -3.1418055234010298e-02,
              1.4508695318321430e+00,
              -2.2138661839877318e-03,
              1.5876418072312805e-02 },
            { -2.1369013568235829e-02,
              -5.0722323934413588e-02,
              -1.4416408387550291e-03,
              3.5377225823679556e-03,
              -4.0426986517121503e-02,
              9.3507564110935132e-04,
              f4,
              1.5589159546527932e-02,
              f6,
              -1.3745340145364777e-03,
              3.2388578862461215e-02,
              -3.9787452090516199e-04,
              1.1453673174337015e-01,
              -1.0261900234952230e+00,
              7.7398701635904038e-02,
              -1.1965642399912900e-01,
              1.0845681784901706e+00,
              -7.5890644276386282e-02,
              5.3103502983576370e-02,
              2.0715614628610882e-01,
              4.8295112694569146e-02,
              -5.6728134305151230e-02,
              -1.4026786357787908e+00,
              6.6649483897991163e-02,
              2.1411773206331110e-03,
              3.3204742129673476e-02,
              -1.1572689385556817e-04,
              6.1512300181789777e-02,
              1.1471111644106067e+00,
              -6.3686551921167622e-02 },
            { 1.7817118899807211e-02,
              -4.0042831407625191e-02,
              -2.6011258679700583e-02,
              -2.1643718869635305e-04,
              -5.7392250956870214e-03,
              -2.3294626305130772e-04,
              f5,
              f6,
              -7.4060215881706359e-02,
              2.0680878503776857e-02,
              3.5350540083140009e-02,
              -4.9231980411224329e-03,
              1.2755242209518000e-01,
              -1.1329769019996478e+00,
              -1.3159510536918024e+00,
              -2.4221800008400095e-02,
              -9.0831284218943029e-02,
              1.3562119739252267e+00,
              5.4743485383638144e-02,
              -1.1617854420489446e+00,
              1.0839569761059016e-01,
              -3.3235698753187805e-02,
              8.7816120727829683e-03,
              -1.3219071243042955e+00,
              -1.0457324254751522e-01,
              1.2776548252685258e+00,
              -3.9264561404051705e-02,
              -2.1403506639894012e-02,
              1.1613346427649027e+00,
              1.3177426867299138e+00 },
            { -6.4766293517364293e-03,
              3.8905043338844812e-03,
              4.4092642955926645e-03,
              1.4977492897290896e-02,
              3.1417894277458606e-02,
              -2.3862195624698698e-02,
              -8.0304588246848062e-04,
              -2.5459940216501851e-04,
              2.3157260771432046e-02,
              1.0739753658519868e-01,
              f7,
              f8,
              -1.3061199649079407e+00,
              6.1397042146159195e-02,
              1.6460603513539673e-01,
              -5.9352728934512600e-02,
              -1.1379307257076846e-01,
              1.1521867167956947e+00,
              -1.2189148938994041e+00,
              1.9169191123998539e-01,
              -1.2083801121871118e+00,
              -3.2288181327178034e-02,
              -2.9910151698698560e-02,
              -1.4229592657142054e+00,
              1.2172439246270419e+00,
              -1.6912856497058912e-01,
              1.3718654051801582e+00,
              1.2843364901937087e+00,
              -7.3213364696688196e-02,
              -1.0797181708449023e-01 },
            { 6.1437024514613371e-03,  -2.6417848472408252e-02,
              -5.2592256484732876e-02, 1.1119542880010623e-03,
              7.6531378609676762e-05,  -4.5595403271467966e-02,
              -4.2457101265712645e-03, -3.7546178534910928e-02,
              -3.0423371751519421e-02, f7,
              2.8443224562340795e-02,  2.9908911550172914e-02,
              1.6164233992560523e-01,  -1.0909980168529594e+00,
              -1.0805712987467595e+00, -3.9693699704909755e-02,
              -3.9586201610349862e-02, 1.1764279118571077e+00,
              4.9391093190967579e-02,  -1.2470988696255823e+00,
              2.5743728428753743e-01,  -3.2020990368492958e-02,
              7.3164683152177459e-02,  -1.4046269427755371e+00,
              -1.2373128165002374e-01, 1.1357708192109168e+00,
              4.5814577043130442e-03,  -1.1649980934745913e-01,
              1.2041918567921661e+00,  1.1454537076308855e+00 },
            { 2.0910313721233243e-02,  3.0932874629455848e-04,
              -3.3648822562493637e-02, 2.5864958886335755e-04,
              -5.0503646686084281e-06, -5.5874691540220888e-03,
              1.1920055935840793e-03,  2.7657856780770843e-03,
              -1.4453280547648576e-02, f8,
              2.9908911550172907e-02,  4.1718701556742593e-02,
              2.2174088295426431e-02,  7.6587858056632402e-02,
              -1.3029589669180388e+00, 1.5249762740563570e-03,
              3.8738244812287696e-03,  -4.8712556530318835e-02,
              6.6056935713142237e-02,  1.4115111929260157e-01,
              -1.1871501292330535e+00, -6.4257999978166350e-02,
              -2.6745245474232536e-02, -6.9440245825369437e-02,
              -2.5481423313071138e-02, -7.9341472877279343e-02,
              1.4087389174162113e+00,  -6.9326254327300496e-02,
              -1.4850505908882683e-01, 1.2114938517979912e+00 }
        };
    }


    template<>
    expected_results_type<LinearAlgebraNS::type::vector>
    GetExpectedVectorP2P1<Advanced::LocalVariationalOperatorNS::SecondPiolaKirchhoffStressTensorNS::
                              ViscoelasticityPolicyNS::DerivatesWithRespectTo::velocity>()
    {
        return expected_results_type<LinearAlgebraNS::type::vector>{ 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                                                     0.0, 0.0, 0.0, 0.0, 0.0, 0.0 };
    }


} // namespace MoReFEM::TestNS::ViscoelasticityNS
// NOLINTEND(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers)


// > *** MoReFEM Doxygen end of group *** //
///@} // \addtogroup TestGroup
// *** MoReFEM Doxygen end of group *** < //
